//### This file created by BYACC 1.8(/Java extension  1.14)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "../src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import java.io.IOException;
//#line 21 "Parser.java"




public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[] = new Value[YYSTACKSIZE];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
final void val_init()
{
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
final void val_push(Value val)
{
  try {
    valptr++;
    valstk[valptr]=val;
  }
  catch (ArrayIndexOutOfBoundsException e) {
    int oldsize = valstk.length;
    int newsize = oldsize*2;
    Value[] newstack = new Value[newsize];
    System.arraycopy(valstk,0,newstack,0,oldsize);
    valstk = newstack;
    valstk[valptr]=val;
  }
}
final Value val_pop()
{
  return valstk[valptr--];
}
final void val_drop(int cnt)
{
  valptr -= cnt;
}
final Value val_peek(int relative)
{
  return valstk[valptr-relative];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short EQUALS=262;
public final static short PACKAGE=263;
public final static short IMPORT=264;
public final static short PUBLIC=265;
public final static short PROTECTED=266;
public final static short PRIVATE=267;
public final static short STATIC=268;
public final static short FINAL=269;
public final static short ABSTRACT=270;
public final static short NATIVE=271;
public final static short STRICTFP=272;
public final static short SYNCHRONIZED=273;
public final static short TRANSIENT=274;
public final static short VOLATILE=275;
public final static short CLASS=276;
public final static short INTERFACE=277;
public final static short ENUM=278;
public final static short THROWS=279;
public final static short EXTENDS=280;
public final static short IMPLEMENTS=281;
public final static short SUPER=282;
public final static short DEFAULT=283;
public final static short BRACEOPEN=284;
public final static short BRACECLOSE=285;
public final static short SQUAREOPEN=286;
public final static short SQUARECLOSE=287;
public final static short PARENOPEN=288;
public final static short PARENCLOSE=289;
public final static short LESSTHAN=290;
public final static short GREATERTHAN=291;
public final static short AMPERSAND=292;
public final static short QUERY=293;
public final static short AT=294;
public final static short JAVADOCSTART=295;
public final static short JAVADOCEND=296;
public final static short JAVADOCEOL=297;
public final static short CODEBLOCK=298;
public final static short PARENBLOCK=299;
public final static short INTEGER_LITERAL=300;
public final static short FLOAT_LITERAL=301;
public final static short IDENTIFIER=302;
public final static short JAVADOCTAG=303;
public final static short JAVADOCTOKEN=304;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   10,    0,    9,    9,    9,    9,    9,    9,   11,
   12,   12,   13,   16,   18,   18,   19,   19,   17,   17,
   21,   20,    1,    1,    1,    8,    5,    5,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,   22,
   22,   22,   23,   23,   24,   24,   24,   24,   24,   24,
    7,    3,   25,   25,   26,   26,   27,   27,   27,   27,
   28,   28,   29,   30,   30,   31,   31,   32,   32,   15,
   33,   34,   34,   36,   36,   36,   38,   38,   39,   39,
   39,   39,   14,   41,   42,   42,   42,   43,   43,   44,
   44,   35,   35,   45,   45,   37,   47,   37,   46,   46,
   46,   46,   46,   46,   46,   46,    4,    4,   51,   53,
   48,   52,   54,   52,   49,   49,   50,   55,   56,   56,
   58,   58,   57,   57,   59,   59,   60,    6,    6,   40,
   40,   61,   61,
};
final static short yylen[] = {                            2,
    0,    0,    3,    1,    1,    1,    1,    1,    1,    3,
    3,    4,    4,    1,    0,    2,    1,    1,    0,    2,
    0,    3,    1,    3,    3,    2,    0,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    2,    0,    2,    5,    0,    2,    2,    4,    4,    2,
    3,    2,    0,    3,    1,    3,    1,    1,    3,    3,
    0,    1,    3,    1,    3,    1,    3,    1,    3,    4,
    4,    1,    3,    0,    1,    3,    2,    2,    1,    2,
    2,    3,    4,    6,    1,    1,    2,    0,    2,    1,
    3,    0,    2,    1,    3,    0,    0,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    0,
    6,    0,    0,    4,    8,    7,    5,    3,    0,    2,
    1,    3,    0,    1,    1,    3,    5,    0,    1,    0,
    2,    0,    2,
};
final static short yydefred[] = {                         1,
    2,    0,    9,    0,    0,   15,    3,    4,    5,    6,
    7,    8,    0,    0,    0,   23,    0,    0,    0,   19,
    0,   29,   30,   31,   32,   33,   34,   35,   39,   36,
   38,   37,   85,   86,    0,    0,   40,   41,    0,    0,
   96,   10,    0,    0,   11,    0,   18,   17,   16,    0,
   87,    0,    0,    0,    0,    0,    0,    0,    0,   25,
   24,   12,   13,   21,   20,    0,   71,   45,    0,    0,
   62,    0,   77,   70,   96,    0,    0,  131,   78,   83,
    0,   15,    0,   94,    0,    0,    0,    0,   64,    0,
    0,   80,    0,    0,   76,  106,   99,  104,  105,    0,
   98,  100,  101,  102,  103,    0,    0,   52,    0,   46,
   45,   44,    0,   50,    0,    0,   63,   90,    0,   84,
   82,  109,    0,    0,    0,    0,    0,   57,    0,   55,
   95,    0,    0,   68,    0,   65,    0,    0,    0,   27,
    0,  110,    0,    0,    0,    0,   54,   49,   48,    0,
   91,    0,    0,    0,  125,    0,    0,    0,    0,   27,
  112,    0,   59,   60,   56,   69,    0,  118,  130,    0,
    0,  107,  108,  117,    0,    0,    0,   27,  133,    0,
  126,    0,   28,    0,  113,  111,    0,  129,    0,    0,
  116,    0,    0,   27,  127,  114,  115,
};
final static short yydgoto[] = {                          1,
   83,   37,  124,  174,  159,  189,  128,  142,    7,    2,
    8,    9,   54,   11,   12,   20,   46,   21,   49,   65,
   82,   13,   38,   86,  108,  129,  130,   70,   71,   88,
   89,  135,   14,   55,   67,   56,   59,   57,   73,   58,
   15,   39,   91,  119,   85,  101,   81,  102,  103,  104,
  105,  177,  161,  192,  139,  157,  153,  171,  154,  155,
  167,
};
final static short yysindex[] = {                         0,
    0,  -69,    0, -290, -208,    0,    0,    0,    0,    0,
    0,    0,   76, -213, -211,    0,   -8, -290,   -3,    0,
 -288,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -212, -146,    0,    0, -157, -228,
    0,    0, -181,    4,    0, -217,    0,    0,    0, -196,
    0,  -83,  -71,  -45,  -32,    6,   -2, -279,  -26,    0,
    0,    0,    0,    0,    0, -290,    0,    0,  -37,   12,
    0,  -74,    0,    0,    0, -228,   -9,    0,    0,    0,
 -229,    0, -177,    0,   34,  -86,   16,  -85,    0, -290,
 -196,    0,   -1,    0,    0,    0,    0,    0,    0,  -38,
    0,    0,    0,    0,    0, -288, -161,    0, -290,    0,
    0,    0,   40,    0, -290,  -37,    0,    0,   41,    0,
    0,    0,   14,   10,    3, -290, -269,    0,  -68,    0,
    0, -207, -143,    0,   18,    0, -290,    0,   27,    0,
   14,    0,    5, -290, -290, -161,    0,    0,    0, -290,
    0,   17,   19,   52,    0, -290, -115,   28,   28,    0,
    0,   14,    0,    0,    0,    0,   53,    0,    0,   55,
   56,    0,    0,    0,   69,  -79, -250,    0,    0,   81,
    0, -290,    0, -115,    0,    0,  -79,    0,   13,   55,
    0,   13, -115,    0,    0,    0,    0,
};
final static short yyrindex[] = {                         0,
    0,  106,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -94,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -238,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   73,
    0, -105,  -33,    0,    0,   74, -134,    0, -168,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -131,
    0,  -40,    0,    0,    0, -238,    0,    0,    0,    0,
    1,    0, -167,    0,   77,    0,  -50,    0,    0,    0,
   73,    0,  -39, -233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -81,    0,    0,    0,    0,
    0,    0, -103,    0,    0,    0,    0,    0,  -80,    0,
    0,    0, -232, -148,    0,    0,  -49,    0,    0,    0,
    0,    0,    0,    0,  -48,    0,    0,   15, -111,    0,
 -235,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   64,    0,   71,    0,    0,    0, -144, -169,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -239,
 -108,    0,    0,    0,    0, -111,    0,    0,    0,   60,
    0,    0,    0,    0,    0,    0, -111,    0,    0, -121,
    0,    0,    0,    0,    0,    0,    0,
};
final static short yygindex[] = {                         0,
   -4,  191,  -63, -109,   36,    0,  -95,  -52,    0,    0,
    0,    0,    2,  282,  283,    0,    0,  285,    0,    0,
    0,  284,  -56,  257,  245,    0,  239,    0,  286,    0,
  271,    0,    0,    0,  297,  313,  315,    0,  333,   75,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -133, -170,    0,    0,    0,  223,
    0,
};
final static int YYTABLESIZE=400;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         17,
   19,   78,   84,   10,  125,  184,  172,  160,   47,  185,
  144,   16,  145,   44,   77,   48,  193,  121,   74,  134,
  121,   27,   72,   97,   27,   23,  118,   96,  178,  114,
  143,   97,   97,   97,   97,   97,   97,   97,   97,   97,
   97,   97,   97,   97,   97,  131,   74,  173,  163,  164,
   27,   73,  110,   23,  166,  130,   97,   23,  121,   18,
   97,   97,   27,  130,   97,    6,    6,  186,   97,   23,
   40,  180,   41,  151,  191,  114,  111,  148,   63,   60,
   43,  113,   97,  197,   66,   64,   77,   26,   97,   50,
   26,   53,   53,   16,   16,   78,   97,   97,   97,   97,
   97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
   53,   53,  107,   53,   51,   51,   53,   60,   53,   26,
   61,   97,   75,   53,   53,   97,   97,  113,   26,   97,
   51,  127,  149,   97,   53,  122,  195,   53,  122,  196,
   16,  172,   53,   53,   53,  119,   51,   51,  120,   88,
   75,  170,   88,   53,   43,   52,   47,   51,   61,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,  110,  116,  158,  122,  190,   43,   43,
   47,   47,  173,   43,   43,   47,  119,    3,   43,  120,
   47,  146,   43,    4,    5,  176,   43,  111,   47,  156,
   89,   14,  112,   89,   68,  117,  175,   77,   14,   66,
   58,   67,  152,  187,   22,   16,   79,   81,   69,   79,
   81,   22,  147,   92,   93,    6,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   66,   58,   67,  152,   79,   81,   61,   61,   42,   43,
   61,   69,   74,   45,   43,   36,   72,   76,   80,  122,
   62,   43,   75,  123,   87,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,  130,
  130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
   42,   90,   52,  109,   42,  115,  121,  133,   42,  107,
  137,  138,   42,  123,  141,  156,  162,  168,  130,  150,
   77,  169,   43,  175,  194,  182,  130,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,  132,  132,
  132,  132,  132,  132,  132,  132,  132,  132,  132,  188,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   16,  183,   92,  179,   72,  124,
   93,  128,   98,   99,  100,  132,  106,  132,  140,   36,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,  165,  126,  136,  120,   95,   94,
   79,  181,    0,    0,    0,    0,    0,    0,    0,   42,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                          4,
    5,   58,   66,    2,  100,  176,  257,  141,  297,  260,
  280,  302,  282,   18,  294,  304,  187,  257,  257,  115,
  260,  257,  302,  257,  260,  258,   90,  257,  162,   86,
  126,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  109,  285,  298,  144,  145,
  286,  285,  260,  286,  150,  294,  290,  290,  298,  268,
  294,  295,  298,  302,  298,  295,  295,  177,  302,  302,
  284,  167,  284,  137,  184,  132,  284,  285,  296,  261,
  258,   86,   81,  193,  281,  303,  294,  257,  257,  302,
  260,  259,  260,  302,  302,  152,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  259,  260,  290,  281,  259,  260,  284,  261,  286,  289,
  302,  290,  257,  291,  292,  294,  295,  132,  298,  298,
  277,  293,  276,  302,  302,  257,  189,  286,  260,  192,
  302,  257,  291,  292,  302,  257,  291,  292,  257,  281,
  285,  156,  284,  302,  260,  302,  260,  302,  302,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  260,  260,  140,  298,  182,  284,  285,
  284,  285,  298,  289,  290,  289,  298,  257,  294,  298,
  294,  260,  298,  263,  264,  160,  302,  284,  302,  279,
  281,  296,  289,  284,  288,  291,  286,  294,  303,  260,
  260,  260,  138,  178,  296,  302,  257,  257,  290,  260,
  260,  303,  291,  298,  299,  295,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  291,  291,  291,  169,  285,  285,  280,  281,  257,  258,
  284,  290,  285,  257,  258,  294,  302,  260,  285,  298,
  257,  258,  257,  302,  302,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  290,  280,  302,  260,  294,  280,  298,  258,  298,  290,
  260,  288,  302,  289,  302,  279,  302,  289,  294,  292,
  294,  260,  258,  286,  302,  260,  302,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  259,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  302,  287,  284,  167,  285,  289,
  284,  302,   81,   81,   81,  302,   82,  111,  124,  294,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  146,  100,  116,   91,   76,   75,
   58,  169,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  294,
};
}
final static short YYFINAL=1;
final static short YYMAXTOKEN=304;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","EQUALS","PACKAGE",
"IMPORT","PUBLIC","PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE",
"STRICTFP","SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","ENUM",
"THROWS","EXTENDS","IMPLEMENTS","SUPER","DEFAULT","BRACEOPEN","BRACECLOSE",
"SQUAREOPEN","SQUARECLOSE","PARENOPEN","PARENCLOSE","LESSTHAN","GREATERTHAN",
"AMPERSAND","QUERY","AT","JAVADOCSTART","JAVADOCEND","JAVADOCEOL","CODEBLOCK",
"PARENBLOCK","INTEGER_LITERAL","FLOAT_LITERAL","IDENTIFIER","JAVADOCTAG",
"JAVADOCTOKEN",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"$$1 :",
"file : file $$1 filepart",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"filepart : enum",
"filepart : SEMI",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"import : IMPORT STATIC fullidentifier SEMI",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCTOKEN",
"javadoctoken : JAVADOCEOL",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$2 :",
"javadoctag : JAVADOCTAG $$2 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers : modifiers modifier",
"modifiers : modifiers annotation",
"modifiers :",
"annotation : AT IDENTIFIER",
"annotation : AT IDENTIFIER PARENOPEN annotationarglist PARENCLOSE",
"annotationarglist :",
"annotationarglist : annotationarglist COMMA",
"annotationarglist : annotationarglist fullidentifier",
"annotationarglist : annotationarglist fullidentifier DOT CLASS",
"annotationarglist : annotationarglist BRACEOPEN annotationarglist BRACECLOSE",
"annotationarglist : annotationarglist annotation",
"type : classtype opt_typearguments dimensions",
"classtype : fullidentifier opt_typearguments",
"opt_typearguments :",
"opt_typearguments : LESSTHAN typearglist GREATERTHAN",
"typearglist : typearg",
"typearglist : typearglist COMMA typearg",
"typearg : type",
"typearg : QUERY",
"typearg : QUERY EXTENDS type",
"typearg : QUERY SUPER type",
"opt_typeparams :",
"opt_typeparams : typeparams",
"typeparams : LESSTHAN typeparamlist GREATERTHAN",
"typeparamlist : typeparam",
"typeparamlist : typeparamlist COMMA typeparam",
"typeparam : IDENTIFIER",
"typeparam : IDENTIFIER EXTENDS typeboundlist",
"typeboundlist : type",
"typeboundlist : typeboundlist AMPERSAND type",
"enum : enum_definition BRACEOPEN enum_body BRACECLOSE",
"enum_definition : modifiers ENUM IDENTIFIER opt_implements",
"enum_body : enum_values",
"enum_body : enum_values SEMI members",
"enum_values :",
"enum_values : enum_value",
"enum_values : enum_value COMMA enum_values",
"enum_value : javadoc enum_constructor",
"enum_value : opt_annotations enum_constructor",
"enum_constructor : IDENTIFIER",
"enum_constructor : IDENTIFIER CODEBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK CODEBLOCK",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER opt_typeparams opt_extends opt_implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"classorinterface : AT INTERFACE",
"opt_extends :",
"opt_extends : EXTENDS extendslist",
"extendslist : classtype",
"extendslist : extendslist COMMA classtype",
"opt_implements :",
"opt_implements : IMPLEMENTS implementslist",
"implementslist : classtype",
"implementslist : implementslist COMMA classtype",
"members :",
"$$3 :",
"members : members $$3 member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : static_block",
"member : class",
"member : enum",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"static_block : modifiers CODEBLOCK",
"$$4 :",
"fields : modifiers type arrayidentifier $$4 extrafields memberend",
"extrafields :",
"$$5 :",
"extrafields : extrafields COMMA $$5 arrayidentifier",
"method : modifiers typeparams type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"method : modifiers type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"constructor : modifiers IDENTIFIER methoddef opt_exceptions memberend",
"methoddef : PARENOPEN opt_params PARENCLOSE",
"opt_exceptions :",
"opt_exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"opt_params :",
"opt_params : paramlist",
"paramlist : param",
"paramlist : paramlist COMMA param",
"param : opt_annotations opt_parammodifiers type varargs arrayidentifier",
"varargs :",
"varargs : DOTDOTDOT",
"opt_annotations :",
"opt_annotations : opt_annotations annotation",
"opt_parammodifiers :",
"opt_parammodifiers : opt_parammodifiers modifier",
};

//#line 333 "../src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
    String sval;
    int ival;
    boolean bval;
    TypeDef type;
}

private void makeField(TypeDef field, String body) {
    FieldDef fd = new FieldDef();
    fd.lineNumber = line;
    fd.modifiers.addAll(modifiers); 
    fd.type = fieldType.name; 
    fd.dimensions = fieldType.dimensions + field.dimensions;
    fd.name = field.name;
    fd.body = body;
    builder.addField(fd);
}
            
//#line 600 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  val_push(yylval);     //save empty value
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 2:
//#line 28 "../src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 10:
//#line 34 "../src/grammar/parser.y"
{ builder.addPackage(val_peek(1).sval); }
break;
case 11:
//#line 37 "../src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 12:
//#line 38 "../src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 14:
//#line 46 "../src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 17:
//#line 53 "../src/grammar/parser.y"
{
        appendToBuffer(val_peek(0).sval);
    }
break;
case 18:
//#line 56 "../src/grammar/parser.y"
{
        textBuffer.append('\n');
    }
break;
case 21:
//#line 63 "../src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 22:
//#line 64 "../src/grammar/parser.y"
{
        builder.addJavaDocTag(new TagDef(val_peek(2).sval.substring(1), buffer(), line)); 
    }
break;
case 23:
//#line 73 "../src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 24:
//#line 74 "../src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 25:
//#line 75 "../src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 26:
//#line 78 "../src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
    }
break;
case 27:
//#line 83 "../src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 28:
//#line 84 "../src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 29:
//#line 90 "../src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 30:
//#line 91 "../src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 31:
//#line 92 "../src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 32:
//#line 93 "../src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 33:
//#line 94 "../src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 34:
//#line 95 "../src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 35:
//#line 96 "../src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 36:
//#line 97 "../src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 37:
//#line 98 "../src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 38:
//#line 99 "../src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 39:
//#line 100 "../src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 40:
//#line 103 "../src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 51:
//#line 125 "../src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(2).sval,val_peek(0).ival);
    }
break;
case 52:
//#line 130 "../src/grammar/parser.y"
{
        yyval.sval = val_peek(1).sval; 
    }
break;
case 70:
//#line 164 "../src/grammar/parser.y"
{
  builder.endClass();
}
break;
case 71:
//#line 168 "../src/grammar/parser.y"
{
    cls.lineNumber = line;
    cls.modifiers.addAll(modifiers); modifiers.clear();
    cls.name = val_peek(1).sval;
    cls.type = ClassDef.ENUM;
    builder.beginClass(cls);
    cls = new ClassDef();
}
break;
case 83:
//#line 195 "../src/grammar/parser.y"
{
        builder.endClass(); 
    }
break;
case 84:
//#line 200 "../src/grammar/parser.y"
{
        cls.lineNumber = line;
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(3).sval;
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 85:
//#line 209 "../src/grammar/parser.y"
{ cls.type = ClassDef.CLASS; }
break;
case 86:
//#line 210 "../src/grammar/parser.y"
{ cls.type = ClassDef.INTERFACE; }
break;
case 87:
//#line 211 "../src/grammar/parser.y"
{ cls.type = ClassDef.ANNOTATION_TYPE; }
break;
case 90:
//#line 216 "../src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).sval); }
break;
case 91:
//#line 217 "../src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).sval); }
break;
case 94:
//#line 222 "../src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).sval); }
break;
case 95:
//#line 223 "../src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).sval); }
break;
case 97:
//#line 225 "../src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 107:
//#line 238 "../src/grammar/parser.y"
{
      yyval.sval = "";
    }
break;
case 108:
//#line 241 "../src/grammar/parser.y"
{
	  yyval.sval = lexer.getCodeBody();
    }
break;
case 109:
//#line 246 "../src/grammar/parser.y"
{ modifiers.clear(); }
break;
case 110:
//#line 251 "../src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 111:
//#line 255 "../src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 113:
//#line 260 "../src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 114:
//#line 260 "../src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 115:
//#line 268 "../src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returns = val_peek(5).type.name;
        mth.dimensions = val_peek(2).ival + val_peek(5).type.dimensions; /* return dimensions can be specified after return type OR after params*/
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 116:
//#line 278 "../src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear();
        mth.returns = val_peek(5).type.name;
        mth.dimensions = val_peek(2).ival + val_peek(5).type.dimensions; /* return dimensions can be specified after return type OR after params*/
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef();
    }
break;
case 117:
//#line 290 "../src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(3).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 121:
//#line 304 "../src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 122:
//#line 305 "../src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 127:
//#line 314 "../src/grammar/parser.y"
{
        param.name = val_peek(0).type.name;
        param.type = val_peek(2).type.name;
        param.dimensions = val_peek(2).type.dimensions + val_peek(0).type.dimensions;
        param.isVarArgs = val_peek(1).bval;
        mth.params.add(param);
        param = new FieldDef();
    }
break;
case 128:
//#line 324 "../src/grammar/parser.y"
{ yyval.bval = false; }
break;
case 129:
//#line 325 "../src/grammar/parser.y"
{ yyval.bval = true; }
break;
case 133:
//#line 330 "../src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
//#line 1052 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
